%global goipath github.com/docker/compose-switch

Summary:            docker-compose CLI shim
Name:               docker-compose-switch
Version:            1.0.5
Release:            2%{?dist}
License:            Apache-2.0
URL:                https://github.com/docker/compose-switch
Source0:            %{url}/archive/refs/tags/v1.0.5.tar.gz #/%{name}-%{version}.tar.gz
# execute 'go mod vendor' under the source code path can generator vendor package
Source1:            %{name}-vendor.tar.gz

BuildRequires:      golang go-rpm-macros

Requires:           docker docker-compose >= 2.0
Requires(post):     %{_sbindir}/update-alternatives
Requires(postun):   %{_sbindir}/update-alternatives
Obsoletes:          docker-compose < 2.0

%description
Compose Switch is a replacement to the Compose V1 docker-compose (python) executable. 
It translates the command line into Compose V2 docker compose then run the latter.

%prep
%autosetup -p1 -a1 -n compose-switch-%{version}

%build
export GOPATH=$PWD/.gopath
mkdir -p ${GOPATH}/src/github.com/docker
ln -sfn $PWD $GOPATH/src/%{goipath}

export CGO_ENABLED=0
export GOFLAGS="-mod=vendor"
export LDFLAGS=" -X github.com/docker/compose-switch/v2/internal.Version=%{version} "
%gobuild -o bin/%{name} %{goipath}

%install
install -D -m 0755 bin/%{name} "%{buildroot}%{_bindir}/%{name}"
mkdir -p %{buildroot}%{_sysconfdir}/alternatives
ln -s -f %{_sysconfdir}/alternatives/docker-compose %{buildroot}%{_bindir}/docker-compose

%check
%gocheck

%post
update-alternatives --install \
   %{_bindir}/docker-compose docker-compose %{_bindir}/%{name} 2000

%postun
if [ ! -f %{_bindir}/%{name} ] ; then
   update-alternatives --remove docker-compose %{_bindir}/%{name}
fi

%files
%license LICENSE
%doc README.md
%{_bindir}/%{name}
%ghost %{_bindir}/docker-compose

%changelog
* Wed Nov 27 2024 jackeyji <jackeyji@tencent.com> - 1.0.5-2
- [Type] bugfix
- [DESC] fix scripts error in postun stage

* Tue Nov 26 2024 jackeyji <jackeyji@tencent.com> - 1.0.5-1
- [Type] other
- [DESC] initial build
